/*
 * Created on 07-07-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package algoritmer;

import java.util.Vector;

/**
 * @author Knud Albrechtsen (SnakeByte)
 */
public class MyEQSort extends AlgorithmExtension implements SortAlgorithm {

private int[] arr;
private Vector vector;

	/**
	 * 
	 */
	public MyEQSort() {
		super();
	}

	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		sort( a, 0, a.length - 1 );
	}
	
	public void brute( int a[], int low, int high ) throws Exception {
		if( ( high - low ) == 1 ) {
			if( a[high] < a[low] ) {
				int tmp = a[low];
				a[low] = a[high];
				a[high] = tmp;
				pause();
			}
		}
		if( ( high - low ) == 2 ) {
			int pmin;
			if( a[low] < a[low+1] ) {
				pmin = low;
			}
			else {
				pmin = low + 1;
			}
			if( a[pmin] < a[low+2] ) {
//				pmin = pmin;
			}
			else {
				pmin = low + 2;
			}
				 
			if( pmin != low ) {
				int tmp = a[low];
				a[low] = a[pmin];
				a[pmin] = tmp;
				pause();
			}
			brute( a, low + 1, high );
		}
		if( ( high - low ) == 3 ) {
			int pmin;
			if( a[low] < a[low+1] ) {
				pmin = low;
			}
			else {
				pmin = low + 1;
			}
			
			if( a[pmin] < a[low+2] ) {
//				pmin = pmin;
			}
			else {
				pmin = low + 2;
			}
			
			if( a[pmin] < a[low+3] ) {
//				pmin = pmin;
			}
			else {
				pmin = low + 3;
			}
			
			if( pmin != low ) {
				int tmp = a[low];
				a[low] = a[pmin];
				a[pmin] = tmp;
				pause();
			}

			int pmax;
			if( a[high] > a[high-1] ) {
				pmax = high;
			}
			else {
				pmax = high - 1;
			}
			
			if( a[pmax] > a[high-2] ) {
//				pmax = pmax;
			}
			else {
				pmax = high - 2;
			}
			
			if( pmax != high ) {
				int T = a[high];
				a[high] = a[pmax];
				a[pmax] = T;
				pause();
			}
			brute( a, low + 1, high - 1 );
		}
	}

	public void sort( int a[], int lo, int hi ) throws Exception {
		int low = lo;
		int high = hi;
		pause( low, high );
		if( ( high - low ) <= 3 ) {
			brute( a, low, high );
			return;
		}
		//Pick a pivot and move it out of the way
		int pivot = a[( low + high ) / 2];
		a[( low + high ) / 2] = a[high];
		a[high] = pivot;
		
		while( low < high ) {
			//Search forward from a[lo] until an element is found that
			//is greater than the pivot or lo >= hi 
			while( a[low] <= pivot && low < high ) {
				low++;
			}
			//Search backward from a[hi] until element is found that
			//is less than the pivot, or hi <= lo 
			while( pivot <= a[high] && low < high ) {
				high--;
			}
			//Swap elements a[lo] and a[hi]
			if( low < high ) {
				int T = a[low];
				a[low] = a[high];
				a[high] = T;
				pause();
			}
		}
		//Put the median in the "center" of the list
		a[hi] = a[high];
		a[high] = pivot;

		//Recursive calls, elements a[lo0] to a[lo-1] are less than or
		//equal to pivot, elements a[hi+1] to a[hi0] are greater than
		//pivot.
		sort( a, lo, low-1 );
		sort( a, high + 1, hi );
	}
	
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med EQSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med EQSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}
}
