/*
 * Created on 07-07-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package algoritmer;

import java.util.*;

/**
 * @author Knud Albrechtsen (SnakeByte)
 */
public class MyExtraStorageMergeSort extends AlgorithmExtension implements SortAlgorithm {

private int[] arr;
private Vector vector;

	/**
	 * 
	 */
	public MyExtraStorageMergeSort() {
		super();
	}

	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		int scratch[] = new int[a.length];
		sort( a, 0, a.length - 1, scratch );
	}
	
	public void sort( int a[], int low, int high, int scratch[] ) throws Exception {
		if( low >= high ) {
			return; /* a[lo] is sorted already   */
		}

		int mid = (low + high) / 2;
		sort( a, low, mid, scratch ); /* Sort sublist a[lo..mid]   */
		sort( a, mid + 1, high, scratch ); /* Sort sublist a[mid+1..hi] */
		
		int k, t_lo = low;
		int t_hi = mid + 1;
		for( k = low; k <= high; k++ ) { /* Merge sorted sublists    */
			if( ( t_lo <= mid ) && ( ( t_hi > high ) || ( a[t_lo] < a[t_hi] ) ) ) {
				scratch[k] = a[t_lo++];
			}
			else {
				scratch[k] = a[t_hi++];
			}
		}
		//kan istedet for at kopiere hver enkelt vrdi over i a
		// a = scratch
		for( k = low; k <= high; k++ ) {
			a[k] = scratch[k]; /* Copy back to a   */
			pause( k );
		}
		arr = a;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med ExtraStorageMergeSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med ExtraStorageMergeSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}

}
