/*
 * Created on 18-06-2003
 */
package algoritmer;

import java.util.*;

/**
 * @author SnakeByte
 *
 * This contents of this file may be used for
 *  private or educational use only.
 */
public class MyQuickSort extends AlgorithmExtension implements SortAlgorithm {

private Vector vector;
private int[] arr;

	/**
	 * 
	 * 
	 */
	public MyQuickSort() {
		super();
	}
	
	/*-------------------array af integers modtages og sorteres------------------*/
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		arr = a;
		sortArray( arr, 0, arr.length  - 1 );
	}
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#sort(int[], int, int)
	 */
	public void sortArray( int[] a, int lo, int hi ) throws Exception {
		int low = lo;
		int high = hi;
		pause( low, high );
		if( low >= high ) {
			return;
		}
		else if( low == high -1 ) {
			 //Sorterer en liste p to elementer. Der swappes hvis ndvendigt
			 if( a[low] > a[high] ) {
				int tmp = a[low];
				a[low] = a[high];
				a[high] = tmp;
			}
			return;
		}
		// Der oprettes en pivot
		int pivot = a[( low + high ) / 2];
		a[(low + high) / 2] = a[high];
		a[high] = pivot;
		while( low < high ) {
			//Sger fremad fra a[lo] til der findes et element, der er strre end pivoten
			//eller slutningen p arrayet nes (lo >= hi).
			while( a[low] <= pivot && low < high ) {
				low++;
			}
			//Sger bagud fra a[hi] til der findes et element, der er mindre end pivoten
			//eller starten p arrayet findes (lo >= hi)
			while( pivot <= a[high] && low < high ) {
				high--;
			}
			//bytter elementerne a[lo] og a[hi]
			if (low < high) {
				int tmp = a[low];
				a[low] = a[high];
				a[high] = tmp;
				pause( low, high );
			}
			if( getStopsort() ) {
				return;
			}
		}
		//Put medianen ind i "midten" af listen.
		a[hi] = a[high];
		a[high] = pivot;
		//Rekursive kald.
		//Elementerne ved a[lo0] til a[lo - 1] er mindre end eller lig pivot.
		//Elementerne ved a[hi0] til a[hi + 1] er strre end pivot.
		sortArray( a, lo, low - 1 );
		sortArray( a, high + 1, hi );
	}
	
	/*------------------------------slut p sortering af arrays------------------*/
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return null;
	}

	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med QuickSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med QuickSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}
}
