/*
 * Created on 07-07-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package algoritmer;

import java.util.*;

/**
 * @author Knud Albrechtsen (SnakeByte)
 */
public class MyShakerSort extends AlgorithmExtension implements SortAlgorithm {

private Vector vector;
private int[] arr;
	/**
	 * 
	 */
	public MyShakerSort() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		int marker1 = 0;
		int marker2 = a.length - 1;
		while( marker1 < marker2 ) {
			int min = marker1;
			int max = marker1;
			int marker3;
			for( marker3 = marker1 + 1; marker3 <= marker2; marker3++ ) {
				if( getStopsort() ) {
					return;
				}
				if( a[marker3] < a[min] ) {
					min = marker3;
				}
				if( a[marker3] > a[max] ) {
					max = marker3;
				}
				pause( marker1, marker3 );
			}
			int tmp = a[min];
			a[min] = a[marker1];
			a[marker1] = tmp;
			pause( marker1, marker2 );
			if( max == marker1 ) {
				tmp = a[min];
				a[min] = a[marker2];
				a[marker2] = tmp;
			}
			else {
				tmp = a[max];
				a[max] = a[marker2];
				a[marker2] = tmp;
			}
			pause( marker1, marker2 );
			marker1++;
			marker2--;
		}
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med ShakerSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med ShakerSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}
}
